
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Project_filesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const project_files = await db.project_files.create(
            {
                id: data.id || undefined,
        
        path: data.path
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        file_kind: data.file_kind
        ||
        null
            ,
            
        is_entry: data.is_entry
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await project_files.setProject( data.project || null, {
            transaction,
        });
        
        await project_files.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return project_files;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const project_filesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                path: item.path
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                file_kind: item.file_kind
            ||
            null
            ,
            
                is_entry: item.is_entry
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const project_files = await db.project_files.bulkCreate(project_filesData, { transaction });

        // For each item created, replace relation files
        

        return project_files;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const project_files = await db.project_files.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.path !== undefined) updatePayload.path = data.path;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.file_kind !== undefined) updatePayload.file_kind = data.file_kind;
        
        
        if (data.is_entry !== undefined) updatePayload.is_entry = data.is_entry;
        
        
        updatePayload.updatedById = currentUser.id;

        await project_files.update(updatePayload, {transaction});

        
        
        if (data.project !== undefined) {
            await project_files.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await project_files.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return project_files;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const project_files = await db.project_files.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of project_files) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of project_files) {
                await record.destroy({transaction});
            }
        });


        return project_files;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const project_files = await db.project_files.findByPk(id, options);

        await project_files.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await project_files.destroy({
            transaction
        });

        return project_files;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const project_files = await db.project_files.findOne(
            { where },
            { transaction },
        );

        if (!project_files) {
            return project_files;
        }

        const output = project_files.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.project = await project_files.getProject({
            transaction
        });
        
        
        output.organizations = await project_files.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.path) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'project_files',
                        'path',
                        filter.path,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'project_files',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.file_kind) {
                where = {
                    ...where,
                file_kind: filter.file_kind,
            };
            }
            
            if (filter.is_entry) {
                where = {
                    ...where,
                is_entry: filter.is_entry,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.project_files.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'project_files',
                        'path',
                        query,
                    ),
                ],
            };
        }

        const records = await db.project_files.findAll({
            attributes: [ 'id', 'path' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['path', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.path,
        }));
    }

    
};

